<template>
    <div class="edit-view">
        <el-form
            :model="formData"
            :rules="rules"
            ref="form"
            label-width="90px"
            label-position="right"
            size="small"
            style="max-width: 500px;"
        >
            <el-form-item prop="level" label="级别">
                <!-- <el-input v-model="formData.level"></el-input> -->
                <el-radio-group v-model="formData.level">
                    <el-radio :label="1">一级专业</el-radio>
                    <el-radio :label="2">二级专业</el-radio>
                    <el-radio :label="3">三级专业</el-radio>
                </el-radio-group>
            </el-form-item>
            <el-form-item label="一级分类" v-if="formData.level != 1">
                <el-select v-model="formData.parent" @change="changeTwo()">
                    <el-option v-for="item in oneArt" :key="item.id" :label="item.name" :value="item.id"></el-option>
                </el-select>
            </el-form-item>
            <el-form-item label="二级分类" v-if="formData.level == 3">
                <el-select v-model="formData.parent1">
                    <el-option v-for="item in twoArt" :key="item.id" :label="item.name" :value="item.id"></el-option>
                </el-select>
            </el-form-item>
            <el-form-item prop="name" label="专业名称">
                <el-input v-model="formData.name"></el-input>
            </el-form-item>
            <el-form-item prop="code" label="专业代码">
                <el-input v-model="formData.code"></el-input>
            </el-form-item>
            <el-form-item>
                <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
                <el-button @click="onDelete" :loading="saving" type="danger" v-if="formData.id">删除 </el-button>
                <el-button @click="$router.go(-1)">取消</el-button>
            </el-form-item>
        </el-form>
    </div>
</template>
<script>
export default {
    name: 'ArtTypeEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('artType/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
        this.$http
            .post('artType/all', { size: 1000, query: { del: false } }, { body: 'json' })
            .then(res => {
                this.art = res.content;
                this.oneArt = this.art.filter(item => {
                    return item.level === 1;
                });
                this.twoArt = this.art.filter(item => {
                    return item.level === 2;
                });
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {},
            art: [],
            oneArt: [],
            twoArt: []
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };
            this.saving = true;
            this.$http
                .post('/artType/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/artType/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                });
        },
        changeTwo() {
            this.twoArt = this.art.filter(item => {
                return item.parent === this.parent;
            });
        }
    }
};
</script>
<style lang="less" scoped></style>
